#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_acodec.h>
#include <stdio.h>

const int WIDTH = 1000;
const int HEIGHT = 500;
const float FPS = 60;
// nomi risorse
ALLEGRO_DISPLAY *display = NULL;
ALLEGRO_BITMAP *sprite1 = NULL;
ALLEGRO_BITMAP *sprite2 = NULL;
ALLEGRO_BITMAP *sprite3_a = NULL;
ALLEGRO_BITMAP *sprite3_b = NULL;
ALLEGRO_BITMAP *sprite3_c = NULL;
ALLEGRO_BITMAP *sprite4 = NULL;
ALLEGRO_BITMAP *background = NULL;
ALLEGRO_BITMAP *scroll = NULL;
ALLEGRO_SAMPLE *music = NULL;
ALLEGRO_TIMER *timer = NULL;
ALLEGRO_EVENT_QUEUE *event_queue = NULL;

void destroy() {
    // distrugge la risorsa se caricata
    if (timer) al_destroy_timer(timer);
    if (event_queue) al_destroy_event_queue(event_queue);
    if (music) al_destroy_sample(music);
    if (sprite1) al_destroy_bitmap(sprite1);
    if (sprite2) al_destroy_bitmap(sprite2);
    if (sprite3_a) al_destroy_bitmap(sprite3_a);
    if (sprite3_b) al_destroy_bitmap(sprite3_b);
    if (sprite3_c) al_destroy_bitmap(sprite3_c);
    if (sprite4) al_destroy_bitmap(sprite4);
    if (background) al_destroy_bitmap(background);
    if (scroll) al_destroy_bitmap(scroll);
    if (display) al_destroy_display(display);
}

int main(int argc, char* argv[]) {

    char c;
    printf("%s\n\n", argv[0]);
    printf("Run da CODE::BLOCK, le risorse devono esistere nella cartella del progetto xxx.cbp\n");
    printf("se lanciato dall'eseguibile le risorse devono esistere nella cartella dell'eseguibile.\n\n");
    printf("Il programma funzionera' in computer che non hanno MinGW e allegro5 se alla compilazione\n");
    printf("si aggiunge -satic (incorpora lib MinGW) e si e' copiato 'allegro_monolith-debug-5.2.dll'\n");
    printf("dalla cartella allegro\\bin nella cartella dell'eseguibile.\n\n");

    if (!al_init()) {
        destroy();
        printf("Errore durante l'inizializzazione di Allegro.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_init_image_addon()) {
        destroy();
        printf("Errore durante l'inizializzazione di image_addon.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    display = al_create_display(WIDTH, HEIGHT);
    if (!display) {
        destroy();
        printf("Errore durante la creazione di create_display.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_install_audio()) {
        destroy();
        printf("Errore durante l'inizializzazione di install_audio.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_init_acodec_addon()) {
        destroy();
        printf("Errore durante l'inizializzazione di acodec_addon.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    sprite1 = al_load_bitmap("Helicopter.png");
    if (!sprite1) {
        destroy();
        printf("Errore durante il caricamento di Helicopter.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    sprite2 = al_load_bitmap("Helicopter2.png");
    if (!sprite2) {
        destroy();
        printf("Errore durante il caricamento di Helicopter2.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    sprite3_a = al_load_bitmap("carro1_a.png");
    if (!sprite3_a) {
        destroy();
        printf("Errore durante il caricamento del carro1_a.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    sprite3_b = al_load_bitmap("carro1_b.png");
    if (!sprite3_b) {
        destroy();
        printf("Errore durante il caricamento del carro1_b.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    sprite3_c = al_load_bitmap("carro1_c.png");
    if (!sprite3_c) {
        destroy();
        printf("Errore durante il caricamento del carro1_c.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    sprite4 = al_load_bitmap("carro2.png");
    if (!sprite4) {
        destroy();
        printf("Errore durante il caricamento del carro2.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    background = al_load_bitmap("sfondo.jpg");
    if (!background) {
        destroy();
        printf("Errore durante il caricamento dello sfondo.jpg.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    scroll = al_load_bitmap("scroll3.png");
    if (!scroll) {
        destroy();
        printf("Errore durante il caricamento dell'immagine scroll3.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    music = al_load_sample("Katy.ogg");
    if (!music) {
        destroy();
        printf("Errore durante il caricamento del file audio Katy.ogg.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_reserve_samples(1)) {
        destroy();
        printf("Errore durante l'assegnazione del flusso audio 1.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    event_queue = al_create_event_queue();
    if (!event_queue) {
        destroy();
        printf("Errore durante la creazione di create_event_queue.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    timer = al_create_timer(1.0 / FPS);
    if (!timer) {
        destroy();
        printf("Errore durante la creazione di create_timer.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    printf("Allegro5 inizializzato, tutte le risorse caricate.\n");

    al_register_event_source(event_queue, al_get_display_event_source(display));
    al_set_window_title(display, "la sequenza di disegno determina chi copre cosa");
    al_play_sample(music, 1.0, 0.0, 1.0, ALLEGRO_PLAYMODE_LOOP, NULL);

    int x = -100;
    int scroll_x = 0;
    int anim = 0;
    bool game_over = false;

    // Ciclo della finestra
    while (!game_over) {

        ALLEGRO_EVENT event; // coda degli eventi
        bool got_event = al_get_next_event(event_queue, &event);

        if (got_event && event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
            game_over = true;
        }

        al_draw_bitmap(background, 0, 0, 0); // sfondo fisso che cancella tutta la scena

        // Aggiorna la posizione delle immagini
        x ++;
        if (x > WIDTH) x = -200; // riparte fuori dallo schermo

        al_draw_bitmap(sprite2, x + 120, 100, 0); // elicottero2 resta dietro le nuvole
        al_draw_bitmap(sprite4, (WIDTH+20) -x * 1.2 , 260, 0); // carro2 resta dietro a carro1_abc
        anim++;
        if (anim == 3) anim=0;
        //se cambiando l'attesa su al_rest, le ruote girano indiero, invertire sprite3_a con sprite3_c
        if (anim == 0) al_draw_bitmap(sprite3_a, x*2-100, 230, 1); // carro1_a resta dietro il muretto/cancello
        if (anim == 1) al_draw_bitmap(sprite3_b, x*2-100, 230, 1); // carro1_b resta dietro il muretto/cancello
        if (anim == 2) al_draw_bitmap(sprite3_c, x*2-100, 230, 1); // carro1_c resta dietro il muretto/cancello

        // Disegna lo scroll con nuvole e cancello due volte,
        // la seconda solo per coprire la larghezza dello schermo
        al_draw_bitmap_region(scroll, 0, 0, 1000, HEIGHT, scroll_x, 0, 0);
        al_draw_bitmap_region(scroll, 0, 0, WIDTH, HEIGHT, scroll_x + 1000, 0, 0);

        al_draw_bitmap(sprite1, x*1.4, 70, 0); // elicottero resta avanti le nuvole

        // Aggiorna la coordinata dello scroll
        scroll_x -= 1;

        // Se l'immagine di scroll  uscita dallo schermo, torna all'inizio
        if (scroll_x <= -1000) {
            scroll_x = 0;
        }

        al_flip_display(); // scambia lo schermo al V_Sync

        al_rest(0.006); // attesa in secondi
    }
    destroy();
    return 0;
}
